"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var t = _ref.types;

  return {
    visitor: {
      // require("TOKEN/lodash")
      CallExpression: function CallExpression(path, state) {
        var node = path.node;
        var args = node.arguments || [];
        var opts = _getOpts(this, path, state.opts);

        if (node.callee.name === "require" && args.length === 1 && t.isStringLiteral(args[0])) {
          (function () {
            var src = args[0].value;

            var _src$split = src.split("/"),
                _src$split2 = _toArray(_src$split),
                first = _src$split2[0],
                rest = _src$split2.slice(1);

            var mod = (rest || []).join("/");

            // Parse options and mutate with first match.
            var replace = opts[Object.keys(opts).find(function (k) {
              return k === first;
            })];
            if (replace) {
              // Rewrite `require` with a clone of stashed node, preserving location.
              node.callee = Object.assign({}, replace, { loc: node.callee.loc });

              // Replace module argument with stripped module path.
              args[0].value = mod;
            }
          })();
        }
      }
    }
  };
};

var _babylon = require("babylon");

var babylon = _interopRequireWildcard(_babylon);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

// Parse options values.
var _parseOpts = function _parseOpts(path, opts) {
  return Object.keys(opts)
  // Parse the matched replacement expression.
  // https://github.com/babel/babylon/issues/210
  .map(function (key) {
    try {
      return [key, babylon.parse("expr=" + opts[key]).program.body.pop().expression.right];
    } catch (err) {
      throw path.buildCodeFrameError(err);
    }
  })
  // Objectify.
  .reduce(function (memo, pair) {
    memo[pair[0]] = pair[1];
    return memo;
  }, {});
};

// Parse, cache, and get options
var _getOpts = function _getOpts(ctxt, path, opts) {
  ctxt._opts = ctxt._opts || _parseOpts(path, opts);
  return ctxt._opts;
};